#include <sourcemod>
#include <vip_core>
#include <geoip>
#include <adminmenu>
#include <multicolors>
#define PLUGIN_VERSION		"1.3.3"
ConVar sPluginEnabled;
ConVar sCanCheck;
ConVar sVIP;
ConVar sSteamID;
ConVar sFlag;
ConVar sAdmin;
ConVar sMember;
ConVar sShow;
ConVar sjoindis;
ConVar sCountry;
int totalmembers = 0;
Handle db = INVALID_HANDLE;
public Plugin myinfo = 
{
    name        = "[ANY] Who is",
    author      = "SLAYER, Vertigo",
    description = "Shows Steamid , Oldest Name, IP Address, Country, VIP Status, Admin Status, Member Number by Using SQLite Database",
    version     = PLUGIN_VERSION,
    url         = "https://forums.alliedmods.net/member.php?u=293943"
};
public void OnPluginStart()
{
	sPluginEnabled = CreateConVar("sm_whois_enabled", "1", "Enable/disable Whois plugin. (0 = Disabled, 1 = Enabled)", FCVAR_NOTIFY, true, 0.0, true, 1.0);
	sCanCheck = CreateConVar("sm_whois_checkip", "1", "Who Can See Player IP Address (0 = ALL, 1 = Admins Only)", FCVAR_NOTIFY, true, 0.0, true, 1.0);
	sFlag = CreateConVar("sm_whois_adminflag", "z", "Admin flag Which can see player IP address");
	sVIP = CreateConVar("sm_whois_vip","1", "Show Player VIP Status (1= Yes, 0 = NO)(Required VIP-Core by R1ko)", FCVAR_NOTIFY, true, 0.0, true, 1.0);
	sSteamID = CreateConVar("sm_whois_steamid","1", "Show Player SteamID (1= Yes, 0 = NO)", FCVAR_NOTIFY, true, 0.0, true, 1.0);
	sAdmin = CreateConVar("sm_whois_admin","1", "Show Player Admin Status (1= Yes, 0 = NO)", FCVAR_NOTIFY, true, 0.0, true, 1.0);
	sMember = CreateConVar("sm_whois_member","1", "Show Player Member Number (1= Yes, 0 = NO)", FCVAR_NOTIFY, true, 0.0, true, 1.0);
	sCountry = CreateConVar("sm_whois_country","1", "Show Player Country Name (1= Yes, 0 = NO)", FCVAR_NOTIFY, true, 0.0, true, 1.0);
	sShow =  CreateConVar("sm_whois_showserver","1", "Show Player Information in Server Console(1= Yes, 0 = NO)", FCVAR_NOTIFY, true, 0.0, true, 1.0);
	sjoindis = CreateConVar("sm_whois_joindis","1", "Show Message on Player Join and Disconnect (1= Yes, 0 = NO)", FCVAR_NOTIFY, true, 0.0, true, 1.0);
	RegConsoleCmd("sm_whois", cmd_whoisplayers);
	AutoExecConfig(true, "SLAYER_Whois");
	InitializeDB();
}
stock bool CheckPlayerFlags(int client)
{
    char sCvarFlags[26];
    sFlag.GetString(sCvarFlags, sizeof(sCvarFlags));
    int CvarFlags = ReadFlagString(sCvarFlags);
    int ClientFlags = GetUserFlagBits(client);
    if(ClientFlags & CvarFlags == CvarFlags){return true;}
    return false;
}
public void InitializeDB()
{
	char error[255];
	db = SQL_ConnectEx(SQL_GetDriver("sqlite"), "", "", "", "slayer_whois", error, sizeof(error), true, 0);
	if(db == INVALID_HANDLE)
	{
		SetFailState(error);
	}
	SQL_LockDatabase(db);
	SQL_FastQuery(db, "CREATE TABLE IF NOT EXISTS slayer_whois (steam_id TEXT, oldname TEXT, member INTEGER, clientname TEXT);");
	SQL_UnlockDatabase(db);
}
public void OnClientAuthorized(int client)
{
	if(sPluginEnabled.BoolValue)
	{
		char queryBuffer1[255];
		Format(queryBuffer1, sizeof(queryBuffer1), "SELECT *FROM slayer_whois");
		SQL_TQuery(db, findtotalmemebers, queryBuffer1, GetClientSerial(client));
		char queryBuffer[255], clientid[40];
		GetClientAuthId(client, AuthId_Engine, clientid, sizeof(clientid));
		Format(queryBuffer, sizeof(queryBuffer), "SELECT *FROM slayer_whois WHERE steam_id='%s'", clientid);
		SQL_TQuery(db, joinCallback, queryBuffer, GetClientSerial(client));
		
	}
}
public void findtotalmemebers(Handle owner, Handle hndl, const char[] error, any clientSerial)
{
        if(hndl == INVALID_HANDLE)
        {
                ThrowError("SQL error: %s", error);
                return;
        }
        if(SQL_GetRowCount(hndl) > 0)
        {
                totalmembers = SQL_GetRowCount(hndl);
        }
        else
        {
               totalmembers = 0; 
        }
}
public void joinCallback(Handle owner, Handle hndl, const char[] error, any clientSerial)
{
	if(hndl == INVALID_HANDLE)
	{
		ThrowError("SQL error: %s", error);
		return;
	}
	int client = GetClientFromSerial(clientSerial);
	char ip[20];
	char country[50];
	GetClientIP(client, ip, sizeof(ip));
	GeoipCountry(ip, country, sizeof country);
	if(!GeoipCountry(ip, country, sizeof country))
    {
		if(!IsFakeClient(client))country = "Unknown Country";
		if(IsFakeClient(client))country = "Console";
    } 
	if(SQL_GetRowCount(hndl) == 0)
	{
		totalmembers++;
		char queryBuffer[255], clientid[32], clientname[MAX_NAME_LENGTH];
		GetClientName(client, clientname, sizeof(clientname));
		GetClientAuthId(client, AuthId_Engine, clientid, sizeof(clientid));
		Format(queryBuffer, sizeof(queryBuffer), "INSERT INTO slayer_whois VALUES ('%s', '%s', %i, '%s')", clientid, clientname, totalmembers, clientname);
		SQL_TQuery(db, Callback, queryBuffer, client);
		if(sjoindis.BoolValue)
		{
			CPrintToChatAll("{darkred}[Whois] {default}Client {green}%s {default}connected to the server from {purple}%s. {darkred}Oldest name : {lime}%s | {purple}Member Number : {orchid}%i/%i", clientname, country, clientname, totalmembers, totalmembers);
			if(sShow.BoolValue)PrintToServer("[Whois] Client %s connected from %s. Old Name: %s | Member Number : %i/%i", clientname, country, clientname, totalmembers, totalmembers);
		}
	}
	else
	{
		char clientname[MAX_NAME_LENGTH];
		GetClientName(client, clientname, sizeof(clientname));
		char oldname[MAX_NAME_LENGTH]; 
		SQL_FetchString(hndl, 1, oldname, sizeof(oldname));
		int clientmember = SQL_FetchInt(hndl, 2);
		if(sjoindis.BoolValue)
		{
			CPrintToChatAll("{darkred}[Whois] {default}Client {green}%s {default}connected to the server from {purple}%s. {darkred}Oldest name : {lime}%s | {purple}Member Number : {orchid}%i/%i", clientname, country, oldname, clientmember, totalmembers);
			if(sShow.BoolValue)PrintToServer("[Whois] Client %s connected from %s. Old Name: %s | Member Number : %i/%i", clientname, country, oldname, clientmember, totalmembers);
		}
	}	
}
public void OnClientDisconnect(int client)
{
	if(sPluginEnabled.BoolValue)
	{
		char queryBuffer[255], clientid[40];
		GetClientAuthId(client, AuthId_Engine, clientid, sizeof(clientid));
		Format(queryBuffer, sizeof(queryBuffer), "SELECT *FROM slayer_whois WHERE steam_id='%s'", clientid);
		SQL_TQuery(db, DisconnectCallback, queryBuffer, GetClientSerial(client));
	}
}
public void DisconnectCallback(Handle owner, Handle hndl, const char[] error, any clientSerial)
{
	if(hndl == INVALID_HANDLE)
	{
		ThrowError("SQL error: %s", error);
		return;
	}
	char clientname[MAX_NAME_LENGTH];
	SQL_FetchString(hndl, 3, clientname, sizeof(clientname));
	char oldname[MAX_NAME_LENGTH]; 
	SQL_FetchString(hndl, 1, oldname, sizeof(oldname));
	int clientmember = SQL_FetchInt(hndl, 2);
	if(sjoindis.BoolValue)
	{
		CPrintToChatAll("{darkred}[Whois] {default}Client {green}%s {default}Disconnected from {purple}Server. {darkred}Oldest name : {lime}%s | {purple}Member Number : {orchid}%i/%i", clientname, oldname, clientmember, totalmembers);
		if(sShow.BoolValue)PrintToServer("[Whois] Client %s Disconnected from Server. Old Name: %s | Member Number : %i/%i", clientname, oldname, clientmember, totalmembers);
	}	
}
public Action cmd_whoisplayers(int client, int args)
{
	if(sPluginEnabled.BoolValue)
	{
		if(client == 0)
		{
			 ReplyToCommand(client, "[Whois] Cannot use command from RCON");
			 return Plugin_Handled;
		} 
		if (args < 1)
		{
		    DisplayClientMenu(client);
		    return Plugin_Handled;
		}
		int target;
		char argstring[128];
		GetCmdArgString(argstring, sizeof(argstring));
		target = FindTarget(client, argstring, true, false);
		if (target <= 0) 
		{
			ReplyToCommand(client, "[Whois] Invalid Usage. Please Entre the Vaild Name");
			DisplayClientMenu(client);
			return Plugin_Handled;
		}
		else 
		{
			char clientid[40];
			char queryBuffer[255];
			GetClientAuthId(target, AuthId_Engine, clientid, sizeof(clientid));
			Format(queryBuffer, sizeof(queryBuffer), "SELECT *FROM slayer_whois WHERE steam_id='%s'", clientid);
			DataPack dataPack = new DataPack();
			WritePackCell(dataPack, GetClientSerial(client));
			WritePackCell(dataPack, GetClientSerial(target));
			SQL_TQuery(db, DataCallback1, queryBuffer, dataPack);
		}
	}
	return Plugin_Handled;
}
public void DataCallback1(Handle owner, Handle hndl, const char[] error, any data)
{
	if(hndl == INVALID_HANDLE)
	{
		ThrowError("SQL error: %s", error);
		return;
	}
	DataPack packData = view_as<DataPack>(data);
	packData.Reset();
	int clientSerial = ReadPackCell(packData);
	int targetClientSerial = ReadPackCell(packData);
	int client = GetClientFromSerial(clientSerial);
 	int targetClient = GetClientFromSerial(targetClientSerial);
	delete packData;
	char ip[20];
	char vip[10];
	char country[50];
	bool Admin;
	char admincheck[10];
	char clientid[40];
	char clientname[MAX_NAME_LENGTH];
	GetClientName(targetClient, clientname, sizeof(clientname));
	GetClientAuthId(targetClient, AuthId_Engine, clientid, sizeof(clientid));
	GetClientIP(targetClient, ip, sizeof(ip));
	GeoipCountry(ip, country, sizeof country)
	char oldname[MAX_NAME_LENGTH]; 
	SQL_FetchString(hndl, 1, oldname, sizeof(oldname));
	int clientmember = SQL_FetchInt(hndl, 2);
	if(!GeoipCountry(ip, country, sizeof country))
    {
		if(!IsFakeClient(targetClient))country = "Unknown Country";
		if(IsFakeClient(targetClient))country = "Console";
    } 
	if(!sCanCheck.BoolValue)
	{
		Admin = false;
	}
	else if(sCanCheck.BoolValue)
	{
		if(CheckPlayerFlags(client))
		{
			Admin = true;
		}
		else
		{
			Admin = false;
		}
	}
	
	vip = "No";
	if (VIP_IsClientVIP(targetClient))
	{
		vip = "Yes";
	}
	if(GetUserAdmin(targetClient) != INVALID_ADMIN_ID)
	{
	 	admincheck = "Yes";
	}
	else
	{
		admincheck = "No";
	}
	CPrintToChat(client, "{darkred}**********************************");
	CPrintToChat(client, "{lime}★ {default}Player Name:{lime} %s", clientname);
	CPrintToChat(client, "{lime}★ {default}Oldest Name:{yellow} %s", oldname);
	if(sSteamID.BoolValue)CPrintToChat(client, "{lime}★ {default}SteamID:{green} %s", clientid);
	if(!sCanCheck.BoolValue && Admin == false)CPrintToChat(client, "{lime}★ {default}IP Address:{orchid} %s", ip);
	else if(sCanCheck.BoolValue && Admin == true)CPrintToChat(client, "{lime}★ {default}IP Address:{orchid} %s", ip);
	if(sCountry.BoolValue)CPrintToChat(client, "{lime}★ {default}Country: {blue}%s", country);
	if(sVIP.BoolValue)CPrintToChat(client, "{lime}★ {default}VIP Status: {purple}%s", vip);
	if(sAdmin.BoolValue)CPrintToChat(client, "{lime}★ {default}Admin Status: {red}%s", admincheck);
	if(sMember.BoolValue)CPrintToChat(client, "{lime}★ {default}Member Number : {lime}%i/%i", clientmember, totalmembers);
	CPrintToChat(client, "{darkred}*********************************");
	if(sShow.BoolValue)
	{
		PrintToServer("*********************************");
		PrintToServer(">> Player Name: %s", clientname);
		PrintToServer(">> Oldest Name: %s", oldname);
		PrintToServer(">> SteamID: %s", clientid);
		PrintToServer(">> IP Address: %s", ip);
		PrintToServer(">> Country: %s", country);
		PrintToServer(">> VIP Status: %s", vip);
		PrintToServer(">> Admin Status: %s", admincheck);
		PrintToServer(">> Member Number : %i/%i", clientmember, totalmembers);
		PrintToServer("*********************************");
	}
}
public void Callback(Handle owner, Handle hndl, const char[] error, any data)
{
	if(!StrEqual("", error))
	{
		PrintToServer("SLAYER_Whois Last Connect SQL Error: %s", error);
	}
}
stock DisplayClientMenu(client)
{
	Handle menu = CreateMenu(MenuHandler_MuteMenu);
	SetMenuTitle(menu, "Choose a player to check his Information");
	SetMenuExitBackButton(menu, true);
	AddTargetsToMenu2(menu, 0,COMMAND_FILTER_CONNECTED);
	DisplayMenu(menu, client, MENU_TIME_FOREVER);
}

public MenuHandler_MuteMenu(Handle menu, MenuAction action, param1, param2)
{
	switch (action)
	{
		case MenuAction_End:
		{
			CloseHandle(menu);
		}
		case MenuAction_Select:
		{
			char info[32];
			int target;
			
			GetMenuItem(menu, param2, info, sizeof(info));
			int userid = StringToInt(info);

			if ((target = GetClientOfUserId(userid)) == 0)
			{
				CPrintToChat(param1, "{darkred}[Whois] {orchid}Player no longer {darkred]Available");
			}
			else
			{
				char clientid[40];
				char queryBuffer[255];
				GetClientAuthId(target, AuthId_Engine, clientid, sizeof(clientid));
				Format(queryBuffer, sizeof(queryBuffer), "SELECT *FROM slayer_whois WHERE steam_id='%s'", clientid);
				DataPack dataPack = new DataPack();
				WritePackCell(dataPack, GetClientSerial(param1));
				WritePackCell(dataPack, GetClientSerial(target));
				SQL_TQuery(db, DataCallback1, queryBuffer, dataPack);
			}
		}
	}
}
